package com.aliyun.security.yunceng.yunceng_flutter_plugin;

import androidx.annotation.NonNull;

import com.aliyun.security.yunceng.android.sdk.YunCeng;

import java.util.HashMap;
import java.util.Map;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;


/** YuncengFlutterPlugin */
public class YuncengFlutterPlugin implements FlutterPlugin, MethodCallHandler {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    channel = new MethodChannel(flutterPluginBinding.getBinaryMessenger(), "yunceng_flutter_plugin");
    channel.setMethodCallHandler(this);
  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
    if (call.method.equals("initEx")) {
      String appKey = call.argument("app_key");
      String token  = call.argument("token");
      int ret = YunCeng.initEx(appKey, token);
      result.success(ret);

    } else if (call.method.equals("getProxyTcpByDomain")) {
      String token     = call.argument("token");
      String groupName = call.argument("group_name");
      String domain    = call.argument("domain");
      String port      = call.argument("port");
      StringBuffer sbIp = new StringBuffer();
      StringBuffer sbPort = new StringBuffer();
      int ret = YunCeng.getProxyTcpByDomain(token, groupName, domain, port, sbIp, sbPort);

      Map<String, Object> map = new HashMap<>();
      map.put("ret",  ret);
      map.put("ip",   sbIp.toString());
      map.put("port", sbPort.toString());
      result.success(map);

    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }
}
