#import "YuncengFlutterPlugin.h"
#import <YunCeng/YunCeng.h>

@implementation YuncengFlutterPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"yunceng_flutter_plugin"
            binaryMessenger:[registrar messenger]];
  YuncengFlutterPlugin* instance = [[YuncengFlutterPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"initEx" isEqualToString:call.method]) {
      NSString* appKey = call.arguments[@"app_key"];
      NSString* token = call.arguments[@"token"];
      int ret = [YunCeng initEx:[appKey UTF8String] :[token UTF8String]];
      result(@(ret));
      
  } else if ([@"getProxyTcpByDomain" isEqualToString:call.method]){
      NSString* token     = call.arguments[@"token"];
      NSString* groupName = call.arguments[@"group_name"];
      NSString* domain    = call.arguments[@"domain"];
      NSString* port      = call.arguments[@"port"];
      
      char proxyIp[128] = {0};
      char proxyPort[32] = {0};
      int ret = [YunCeng getProxyTcpByDomain:[token UTF8String] :[groupName UTF8String] :[domain UTF8String] :[port UTF8String] :proxyIp :128 :proxyPort :32];
      
      NSDictionary* dict = @{
          @"ret": @(ret),
          @"ip": [NSString stringWithUTF8String:proxyIp],
          @"port": [NSString stringWithUTF8String:proxyPort]
      };
      result(dict);
  } else {
      result(FlutterMethodNotImplemented);
  }
}

@end
